All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH v5] generic: test small swapfile without page-aligned contiguous blocks
@ 2021-07-26  9:46 Zorro Lang
  2021-07-26 18:11 ` Darrick J. Wong
  0 siblings, 1 reply; 4+ messages in thread
From: Zorro Lang @ 2021-07-26  9:46 UTC (permalink / raw)
  To: fstests

If a swapfile doesn't contain even a single page-aligned contiguous
range of blocks, it's an invalid swapfile, and might cause kernel
issue. This case covered commit 5808fecc5723 ("iomap: Fix negative
assignment to unsigned sis->pages in iomap_swapfile_activate").

Reviewed-by: Ritesh Harjani <riteshh@linux.ibm.com>
Signed-off-by: Zorro Lang <zlang@redhat.com>
---

Hi,

V5 rebase this case on the latest xfstests, to match the "group info" change:
https://lore.kernel.org/fstests/60d89a67.1c69fb81.86c2c.d6c4@mx.google.com/

Thanks,
Zorro

 tests/generic/640     | 77 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/640.out |  2 ++
 2 files changed, 79 insertions(+)
 create mode 100755 tests/generic/640
 create mode 100644 tests/generic/640.out

diff --git a/tests/generic/640 b/tests/generic/640
new file mode 100755
index 00000000..494fcc1b
--- /dev/null
+++ b/tests/generic/640
@@ -0,0 +1,77 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021 Red Hat Inc.  All Rights Reserved.
+#
+# FS QA Test 640
+#
+# Test small swapfile which doesn't contain even a single page-aligned contiguous
+# range of blocks. This case covered commit 5808fecc5723 ("iomap: Fix negative
+# assignment to unsigned sis->pages in iomap_swapfile_activate").
+#
+. ./common/preamble
+_begin_fstest auto quick swap
+
+# Import common functions
+. ./common/filter
+
+# real QA test starts here
+_supported_fs generic
+_require_scratch
+_require_scratch_swapfile
+_require_test_program mkswap
+_require_test_program swapon
+_require_xfs_io_command fcollapse
+
+make_unaligned_swapfile()
+{
+	local fname=$1
+	local n=$((psize / bsize - 1))
+
+	# Make sure the swapfile doesn't contain even a single page-aligned
+	# contiguous range of blocks. This's necessary to cover the bug
+	$XFS_IO_PROG -f -t -c "pwrite 0 $(((psize + bsize) * n))" $fname >> $seqres.full 2>&1
+	for((i=1; i<=n; i++));do
+		$XFS_IO_PROG -c "fcollapse $(((psize - bsize) * i)) $bsize" $fname
+	done
+	chmod 0600 $fname
+	$CHATTR_PROG +C $fname > /dev/null 2>&1
+	$here/src/mkswap $fname
+}
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+psize=`get_page_size`
+bsize=`_get_file_block_size $SCRATCH_MNT`
+# Due to we need page-unaligned blocks, so blocksize < pagesize is necessary.
+# If not, try to make a smaller enough block size
+if [ $bsize -ge $psize ];then
+	_scratch_unmount
+	_scratch_mkfs_blocksized 1024 >> $seqres.full 2>&1
+	if [ $? -ne 0 ];then
+		_notrun "Can't make filesystem block size < page size."
+	fi
+	_scratch_mount
+	bsize=`_get_file_block_size $SCRATCH_MNT`
+	if [ $bsize -ne 1024 ];then
+		_notrun "Can't force 1024-byte file block size."
+	fi
+fi
+swapfile=$SCRATCH_MNT/$seq.swapfile
+make_unaligned_swapfile $swapfile
+# Expect EINVAL from swapon. If not, might miss 5808fecc5723 ("iomap: Fix
+# negative assignment to unsigned sis->pages in iomap_swapfile_activate")
+$here/src/swapon $swapfile
+# Further testing, check if swap size <= swapfile size, if swapon passed
+if [ $? -eq 0 ];then
+	swapsize=$(awk -v fname="$swapfile" '{if ($1~fname) print $3}' /proc/swaps)
+	swapsize=$((swapsize * 1024))
+	filesize=$(_get_filesize $swapfile)
+	if [ $swapsize -gt $filesize ]; then
+		echo "Allocated swap size($swapsize) shouldn't be greater than swapfile size($filesize)"
+	fi
+fi
+swapoff $swapfile 2>/dev/null
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/640.out b/tests/generic/640.out
new file mode 100644
index 00000000..e1ab5390
--- /dev/null
+++ b/tests/generic/640.out
@@ -0,0 +1,2 @@
+QA output created by 640
+swapon: Invalid argument
-- 
2.31.1


^ permalink raw reply related	[flat|nested] 4+ messages in thread

end of thread, other threads:[~2021-07-27 18:38 UTC | newest]

Thread overview: 4+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2021-07-26  9:46 [PATCH v5] generic: test small swapfile without page-aligned contiguous blocks Zorro Lang
2021-07-26 18:11 ` Darrick J. Wong
2021-07-27  2:41   ` Zorro Lang
2021-07-27 18:38     ` Darrick J. Wong

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.